{% extends '../base.html'%} {% block main %} {% load static %} {% load socialaccount %}

<style>
  .password-eye {
    top: 35px !important;
  }
</style>

<div class="main-container auth">
  <div class="sections">
    <div class="actions">
      <button class="btn btn-active" onclick="showLoginForm()" id="loginBtn">
        Se connecter
      </button>
      <button class="btn" onclick="showRegisteForm()" id="registeBtn">
        S'inscrire
      </button>
    </div>
    <section id="login" class="section-active">
      <div class="auth-img">
        <img src="{% static 'images/logo.png' %}" alt="LOGO" />
      </div>
      <form method="POST">
        {% csrf_token %}
        <div class="col position-relative">
          <label for="email">Votre adresse e-mail :</label>
          <input
            type="email"
            name="login-email"
            id="login-email"
            placeholder="Ex : jon.snow@gmail.com"
            required
          />
          <i class="fa-solid fa-envelope cost-auth-icon"></i>
        </div>
        <div class="col position-relative">
          <label for="password1">Votre mot de passe :</label>
          <input
            type="password"
            name="login-password"
            id="login-password1"
            placeholder="************"
            required
          />
          <button
            type="button"
            onclick="showHidePassword(this)"
            style="border: none; background-color: transparent"
          >
            <i class="fa-solid fa-eye-slash cost-auth-icon"></i>
          </button>
        </div>
        <div class="col col-btn">
          <button class="btn" type="submit">Se connecter</button>
        </div>
        <div class="col">
          <h5 class="text-center">Ou se connecter avec</h5>
        </div>
        <input type="hidden" name="gole" value="login" />
        <div class="col col-btn-cost">
          <a href="{% provider_login_url 'google' %}?next={{ request.path }}"
            ><i class="fa-brands fa-google"></i
          ></a>
        </div>
      </form>
    </section>
    <section id="registe" class="section-unactive">
      <div class="auth-img">
        <img src="{% static 'images/logo.png' %}" alt="LOGO" />
      </div>
      <form method="POST">
        {% csrf_token %}
        <div class="col position-relative">
          <label for="{{ registe_form.first_name.id_for_label }}"
            >Votre prénom :</label
          >
          {{ registe_form.first_name }}
          <i class="fa-sharp fa-solid fa-address-card cost-auth-icon"></i>
        </div>
        <div class="col position-relative">
          <label for="{{ registe_form.last_name.id_for_label }}"
            >Votre nom :</label
          >
          {{ registe_form.last_name }}
          <i class="fa-sharp fa-solid fa-address-card cost-auth-icon"></i>
        </div>
        <div class="col position-relative">
          <label for="{{ registe_form.email.id_for_label }}"
            >Votre adresse e-mail :</label
          >
          {{ registe_form.email }}
          <i class="fa-solid fa-envelope cost-auth-icon" style="top: 38%"></i>
          <span class="w-100 ps-3 pt-1 text-danger d-none" id="email-validator"
            >Email existe déjà, essayer un autre !</span
          >
        </div>
        <div class="col position-relative">
          <label for="{{ registe_form.password1.id_for_label }}"
            >Votre mot de passe :</label
          >
          {{ registe_form.password1 }}
          <button
            type="button"
            onclick="showHidePasswordInputs(this)"
            style="border: none; background-color: transparent"
          >
            <i class="fa-solid fa-eye-slash cost-auth-icon password-eye"></i>
          </button>
          <div>
            <ul class="password-requirements">
              <li class="text-warning" id="inputRuleAll">
                Votre mot de passe doit contenir :
              </li>
              <li class="text-danger" id="inputRule8Car">
                Au moins 8 caractères
              </li>
              <li class="text-danger" id="inputRule1Min">
                Au moins 1 lettre minuscule
              </li>
              <li class="text-danger" id="inputRule1Maj">
                Au moins 1 lettre majuscule
              </li>
              <li class="text-danger" id="inputRule1dig">Au moins 1 chiffre</li>
              <li class="text-danger" id="inputRule1Sp">
                Au moins 1 caractère spécial
              </li>
            </ul>
          </div>
        </div>
        <div class="col position-relative">
          <label for="{{ registe_form.password2.id_for_label }}"
            >Confirmez votre mot de passe :</label
          >
          {{ registe_form.password2 }}
          <button
            type="button"
            onclick="showHidePassword(this)"
            style="border: none; background-color: transparent"
          >
            <i class="fa-solid fa-eye-slash cost-auth-icon"></i>
          </button>
        </div>
        <div>
          {% if registe_form.errors %}
          <div class="errer">{{ registe_form.errors }}</div>
          {% endif %}
        </div>
        <div class="col col-btn">
          <button class="btn" type="submit">S'inscrire</button>
        </div>
        <div class="col">
          <h5 class="text-center">Ou se connecter avec</h5>
        </div>
        <input type="hidden" name="gole" value="registe" />
        <div class="col col-btn-cost">
          <a href="{% provider_login_url 'google' %}?next={{ request.path }}"
            ><i class="fa-brands fa-google"></i
          ></a>
        </div>
      </form>
    </section>
  </div>
  <script>
    const passwords = document.querySelectorAll("input[type='password']");
    passwords.forEach((password) => {
      password.setAttribute("placeholder", "**************");
    });
    const emailInput = document.querySelector("#id_email");
    emailInput.addEventListener("input", async (e) => {
      const email = e.target.value;
      const emailValidator = document.querySelector("#email-validator");
      if (await validateEmail(email)) {
        emailValidator.classList.remove("d-none");
        emailInput.classList.remove("green-border");
        emailInput.classList.add("red-border");
      } else {
        emailValidator.classList.add("d-none");
        emailInput.classList.add("green-border");
        emailInput.classList.remove("red-border");
      }
    });

    const passwordInput = document.querySelector("#id_password1");
    passwordInput.addEventListener("input", (e) => {
      validatePassword1(e.target.value);
    });
    const passwordInput2 = document.querySelector("#id_password2");
    passwordInput2.addEventListener("input", (e) => {
      pass1EquelPass2(e.target.value);
    });

    function validatePassword1(password) {
      const inputRuleAll = document.querySelector("#inputRuleAll");
      const inputRule8Car = document.querySelector("#inputRule8Car");
      const inputRule1Min = document.querySelector("#inputRule1Min");
      const inputRule1Maj = document.querySelector("#inputRule1Maj");
      const inputRule1dig = document.querySelector("#inputRule1dig");
      const inputRule1Sp = document.querySelector("#inputRule1Sp");
      const passwordRegex =
        /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[@$!%*?&])[A-Za-z\d@$!%*?&]{8,}$/;
      // check if the password has all requesment, if so set inputRuleAll to text-success else pass
      // if not all req, set danger to the inputElement else set success
      if (passwordRegex.test(password)) {
        inputRuleAll.classList.remove("text-warning");
        inputRuleAll.classList.add("text-success");
        inputRule8Car.classList.remove("text-danger");
        inputRule1Min.classList.remove("text-danger");
        inputRule1Maj.classList.remove("text-danger");
        inputRule1dig.classList.remove("text-danger");
        inputRule1Sp.classList.remove("text-danger");
        inputRule8Car.classList.add("text-success");
        inputRule1Min.classList.add("text-success");
        inputRule1Maj.classList.add("text-success");
        inputRule1dig.classList.add("text-success");
        inputRule1Sp.classList.add("text-success");
        passwordInput.classList.remove("red-border");
        passwordInput.classList.add("green-border");
      } else {
        inputRuleAll.classList.add("text-warning");
        inputRuleAll.classList.remove("text-success");
        passwordInput.classList.add("red-border");
        passwordInput.classList.remove("green-border");
        if (password.length < 8) {
          inputRule8Car.classList.add("text-danger");
          inputRule8Car.classList.remove("text-success");
        } else {
          inputRule8Car.classList.remove("text-danger");
          inputRule8Car.classList.add("text-success");
        }
        if (!password.match(/[a-z]/)) {
          inputRule1Min.classList.add("text-danger");
          inputRule1Min.classList.remove("text-success");
        } else {
          inputRule1Min.classList.remove("text-danger");
          inputRule1Min.classList.add("text-success");
        }
        if (!password.match(/[A-Z]/)) {
          inputRule1Maj.classList.add("text-danger");
          inputRule1Maj.classList.remove("text-success");
        } else {
          inputRule1Maj.classList.remove("text-danger");
          inputRule1Maj.classList.add("text-success");
        }
        if (!password.match(/[0-9]/)) {
          inputRule1dig.classList.add("text-danger");
          inputRule1dig.classList.remove("text-success");
        } else {
          inputRule1dig.classList.remove("text-danger");
          inputRule1dig.classList.add("text-success");
        }
        if (!password.match(/[@$!%*?&]/)) {
          inputRule1Sp.classList.add("text-danger");
          inputRule1Sp.classList.remove("text-success");
        } else {
          inputRule1Sp.classList.remove("text-danger");
          inputRule1Sp.classList.add("text-success");
        }
      }
    }

    function pass1EquelPass2(password2) {
      const password1 = document.querySelector("#id_password1");
      const password2Input = document.querySelector("#id_password2");
      if (password1.value === password2) {
        password2Input.classList.remove("red-border");
        password2Input.classList.add("green-border");
      } else {
        password2Input.classList.add("red-border");
        password2Input.classList.remove("green-border");
      }
    }

    async function validateEmail(email) {
      const csrfToken = document.querySelector(
        'input[name="csrfmiddlewaretoken"]'
      ).value;
      const response = await fetch("/api/email_exists", {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
          "X-CSRFToken": csrfToken,
        },
        body: JSON.stringify({ email }),
      });
      const result = await response.json();
      return result.code === 0 ? false : true;
    }
  </script>
</div>

{% endblock main%}
